;
;	>>> R.G.B.A. - Rasters Girls Beer Atari by JAC! <<<
;
;	TIP graphics cuts including their metadata.
;	Requires 17 bytes starting at cut_zp.
;
; 	Girls widths: 94,104,88 pixel i.e. 12,13,11 chars = 36 bytes in total

;	Index	Register Original Color
;	0	$d012	  0	=> Color 0 for GRAPHICS 10
;	1	$d013	  2
;	2	$d014	  4
;	3	$d015	  6
;	4	$d016	  8
;	5	$d017	 10
;	6	$d018	 12
;	7	$d019	 14
;	8	$d01a	  0	=> Color/Luma 0 for for GRAPHICS 9/11
;
;	@com.wudsn.ide.asm.mainsourcefile=RGBA.asm

	.proc cut
	cut_visible	= cut_zp+0	;.byte, $00 if not, $ff is yes
	cut_width	= cut_zp+1	;.byte
	cut_width4	= cut_zp+2	;.byte
	cut_start	= cut_zp+3	;.byte
	cut_end		= cut_zp+4	;.byte
	cut_maskp0_ptr	= cut_zp+5	;.word
	cut_maskm0_ptr	= cut_zp+7	;.word
	cut_mask_ptr	= cut_zp+9	;.word
	cut_sm09_ptr	= cut_zp+11	;.word
	cut_sm10_ptr	= cut_zp+13	;.word
	cut_sm11_ptr	= cut_zp+15	;.word

	.proc next
	inc fill_buffer+1
	rts
	.endp

	.proc fill_buffer
	lda #1
	.if .def three_girls_mode
	and #3
	sta fill_buffer+1
	cmp #3
	sne
	lda #1
	.else
	and #1
	.endif
	tax
	lda cut_data.width,x
	sta cut_width
	asl
	asl
	sec
	sbc #1
	sta cut_width4

	lda cut_data.offset,x
	sta cut_start
	clc
	adc cut_width
	sta cut_end

	lda cut_data.addresses.maskp0.lo,x
	sta cut_maskp0_ptr
	lda cut_data.addresses.maskp0.hi,x
	sta cut_maskp0_ptr+1

	lda cut_data.addresses.maskm0.lo,x
	sta cut_maskm0_ptr
	lda cut_data.addresses.maskm0.hi,x
	sta cut_maskm0_ptr+1

	lda cut_data.addresses.mask.lo,x
	sta cut_mask_ptr
	lda cut_data.addresses.mask.hi,x
	sta cut_mask_ptr+1

	lda cut_data.addresses.sm09.lo,x
	sta cut_sm09_ptr
	lda cut_data.addresses.sm09.hi,x
	sta cut_sm09_ptr+1
	lda cut_data.addresses.sm10.lo,x
	sta cut_sm10_ptr
	lda cut_data.addresses.sm10.hi,x
	sta cut_sm10_ptr+1
	lda cut_data.addresses.sm11.lo,x
	sta cut_sm11_ptr
	lda cut_data.addresses.sm11.hi,x
	sta cut_sm11_ptr+1
	rts
	.endp

	.proc check_mask	;IN: <A>=x position between 0..39, <Y>=y position between 0..24, OUT: A=$00 (mask free)/$ff (mask set), destroys <A>, <X>
	cmp cut_end
	bcs mask_free
	sec
	sbc cut_start
	bcc mask_free
	tax
	lda cut_data.mask_offsets.lo,y
	clc
	adc cut_mask_ptr
	sta load+1
	lda cut_data.mask_offsets.hi,y
	adc cut_mask_ptr+1
	sta load+2
load	lda $ffff,x
	and cut_visible
 	rts
mask_free
 	lda #0
 	rts
 	.endp
 
 	.proc count_mask	;IN: <Y>=y position between 0..24, OUT: <Y>=number of non empty mask bytes
 	lda cut_data.mask_offsets.lo,y
 	clc
	adc cut_mask_ptr
	sta load+1
	lda cut_data.mask_offsets.hi,y
	adc cut_mask_ptr+1
	sta load+2
	ldx #mask_sm_width-1
	ldy #0
load	lda $ffff,x
	beq free
	iny
free	dex
	bpl load
	rts
	.endp
	

;===============================================================

	.local cut_data		;about 30A4 bytes

	.local colors
	.byte 0,2,4,6,8,10,12,14,0
	.endl

 	
	.local width
	.byte 12,13
	.if .def three_girls_mode
	.byte 11
	.endif
	.endl

	.local offset
	.byte 0,27
	.if .def three_girls_mode
	.byte 0
	.endif
	.endl

	.local addresses

	.local maskp0
	offset = 0
lo	.byte <[cut_data.cut1+offset], <[cut_data.cut2+offset]
	.if .def three_girls_mode
	.byte <[cut_data.cut3+offset]
	.endif
hi	.byte >[cut_data.cut1+offset], >[cut_data.cut2+offset]
	.if .def three_girls_mode
	.byte >[cut_data.cut3+offset]
	.endif
	.endl

	.local maskm0
	offset = maskp0.offset+mask_pm_lines
lo	.byte <[cut_data.cut1+offset], <[cut_data.cut2+offset]
	.if .def three_girls_mode
	.byte <[cut_data.cut3+offset]
	.endif
hi	.byte >[cut_data.cut1+offset], >[cut_data.cut2+offset]
	.if .def three_girls_mode
	.byte >[cut_data.cut3+offset]
	.endif
	.endl

	.local mask
	offset = maskm0.offset+mask_pm_lines
lo	.byte <[cut_data.cut1+offset], <[cut_data.cut2+offset]
	.if .def three_girls_mode
	.byte <[cut_data.cut3+offset]
	.endif
hi	.byte >[cut_data.cut1+offset], >[cut_data.cut2+offset]
	.if .def three_girls_mode
	.byte >[cut_data.cut3+offset]
	.endif
	.endl

	.local sm09
	offset1 = mask.offset+mask_sm_size
	offset2 = mask.offset+mask_sm_size
	offset3 = mask.offset+mask_sm_size
lo	.byte <[cut_data.cut1+offset1], <[cut_data.cut2+offset2]
	.if .def three_girls_mode
	.byte <[cut_data.cut3+offset3]
	.endif
hi	.byte >[cut_data.cut1+offset1], >[cut_data.cut2+offset2]
	.if .def three_girls_mode
	.byte >[cut_data.cut3+offset3]
	.endif
	.endl

	.local sm10
	offset1 = mask.offset+mask_sm_size+12*tip_lines
	offset2 = mask.offset+mask_sm_size+13*tip_lines
	offset3 = mask.offset+mask_sm_size+11*tip_lines
lo	.byte <[cut_data.cut1+offset1], <[cut_data.cut2+offset2]
	.if .def three_girls_mode
	.byte <[cut_data.cut3+offset3]
	.endif
hi	.byte >[cut_data.cut1+offset1], >[cut_data.cut2+offset2]
	.if .def three_girls_mode
	.byte >[cut_data.cut3+offset3]
	.endif
	.endl

	.local sm11
	offset1 = mask.offset+mask_sm_size+12*tip_lines*2
	offset2 = mask.offset+mask_sm_size+13*tip_lines*2
	offset3 = mask.offset+mask_sm_size+11*tip_lines*2
lo	.byte <[cut_data.cut1+offset1], <[cut_data.cut2+offset2]
	.if .def three_girls_mode
	.byte <[cut_data.cut3+offset3]
	.endif
hi	.byte >[cut_data.cut1+offset1], >[cut_data.cut2+offset2]
	.if .def three_girls_mode
	.byte >[cut_data.cut3+offset3]
	.endif
	.endl

	.endl		;End of addresses

 	.local mask_offsets
lo 	.rept mask_sm_lines,#
	.byte <[:1*mask_sm_width]
 	.endr

hi	.rept mask_sm_lines,#
	.byte >[:1*mask_sm_width]
 	.endr
 	.endl
 	
cut1	ins "gfx/cut/chicks-1.cut"
cut2	ins "gfx/cut/chicks-2.cut"
	.if .def three_girls_mode
cut3	ins "gfx/cut/chicks-3.cut"
	.endif
	.endl


	m_info cut_data

	.endp		;End of cut