
;	>>> R.G.B.A. - Rasters Girls Beer Atari by JAC! <<<
;
;	Hires interlace effects.
;
;	@com.wudsn.ide.asm.mainsourcefile=RGBA.asm

	.proc disco

index_cnt	= 96
index_max	= index_cnt-1	;Minimum is 0

disco_curve_max = 96*4

disco_curve_lo	= $c000
disco_curve_hi	= $c100
disco_charset	= $c400
disco_sm	= $e000	;4*5=20 pages, at $e0, $e5, $ea, $f0 (in order to nor cross 4k boundary)
disco_sm_end	= $f5ff	;Not $f4ff!

disco_rows 	= 4
disco_row_height= 5
disco_row_width	= 256
disco_row_offset= 71
disco_row_size	= disco_row_height*disco_row_width

disco_zp		= effect_zp
disco_vbi_temp		= disco_zp
disco_state		= disco_vbi_temp+1
disco_row_state		= disco_state+1
disco_row_color		= disco_row_state+disco_rows
disco_row_dir_in	= disco_row_color+disco_rows
disco_row_speed_in	= disco_row_dir_in+disco_rows
disco_row_dir_out	= disco_row_speed_in+disco_rows
disco_row_speed_out	= disco_row_dir_out+disco_rows

disco_row_dir		= disco_row_speed_out+disco_rows
disco_row_speed		= disco_row_dir+disco_rows
disco_row_index		= disco_row_speed+disco_rows
disco_row_xlo		= disco_row_index+disco_rows
disco_row_xhi		= disco_row_xlo+disco_rows

disco_row_buffer.size		= $20
disco_row_buffer.char_offsets	= disco_row_xhi+disco_rows
disco_row_buffer.char_lengths	= disco_row_buffer.char_offsets+disco_row_buffer.size
disco_zp_end			= disco_row_buffer.char_lengths+disco_row_buffer.size

	m_info disco_zp disco_zp_end

	.enum row_state
	not_used = 0
	starting = 1
	moving_in = 2
	waiting = 3
	moving_out = 4
	moved_out = 5
	.ende

	.proc init

	jsr main_screen.init	;Temporary black screen

	m_fill_memory disco_sm [disco_sm_end+1-disco_sm] $00
	m_copy_memory disco_font.charset_start disco_charset $400

	m_init_squares init_squares_callback 5

	ldx #disco_rows-1
loop	mva #row_state.not_used disco_row_state,x
	lda #index_max
	sta disco_row_index,x
	dex
	bpl loop
	stx disco_state
	jsr disco_screen.update_dl

	ldx #<disco_screen.vbi
	ldy #>disco_screen.vbi
	jmp system.set_vbiv

;===============================================================

	.proc init_squares_callback	;IN: <X>=index
	clc
	lda init_squares.shifted_value
	adc #48*4
	sta disco_curve_lo,x
	lda init_squares.shifted_value+1
	adc #0
	sta disco_curve_hi,x 
	rts
	.endp

	.endp

;===============================================================

	.proc execute
	
	jsr main_screen.fade_border_in

	.proc animate_rows
	ldx #disco_rows-1
loop	jsr animate_row
	dex
	bpl loop
	rts
	
	.proc animate_row
	bitmask = x1

	lda disco_row_state,x
	cmp #row_state.starting
	bne skip

	jsr disco_text.get_byte
	sta bitmask

	asl bitmask
	lda #0
	ror
	sta disco_row_dir_in,x
	lda #$fe
	asl bitmask
	adc #0
	sta disco_row_speed_in,x

	asl bitmask
	lda #0
	ror
	sta disco_row_dir_out,x
	lda #0
	asl bitmask
	adc #1
	sta disco_row_speed_out,x

	lda bitmask		;Remaining upper 4 bits are color
	sta disco_row_color,x

	lda #index_max
	sta disco_row_index,x
	jsr disco_screen.print_row
	jsr set_next_row_state
skip	rts
	
	.endp
	
	.endp

;===============================================================

	.proc set_next_row_state
	inc disco_row_state,x
	lda disco_row_state,x		;IN: <X>=row number
	cmp #row_state.moving_in
	bne not_moving_in
	mva disco_row_dir_in,x disco_row_dir,x
	mva disco_row_speed_in,x disco_row_speed,x
	rts

not_moving_in
	cmp #row_state.moving_out
	bne not_moving_out
	mva disco_row_dir_out,x disco_row_dir,x
	mva disco_row_speed_out,x disco_row_speed,x
	rts

not_moving_out
	cmp #row_state.moved_out
	bne not_moved_out
	mva #row_state.not_used disco_row_state,x;Unused state again

not_moved_out
	rts
	.endp

	.endp

;===============================================================
	.proc disco_screen

	.proc vbi
	jsr main_screen.set_vbi_defaults

;	Set DLPTR, DMACTL, SYSTEM.DLIV, DLI.KERNELV
	mwa #disco_dl dlptr
	mva #$23 dmactl
	mwa #main_screen.dli_upper_border system.dliv
	mwa #do_kernel main_screen.dli_upper_border.kernelv
	jmp update_dl
	.endp

;===============================================================

	.proc do_kernel	;Reuse main screen DLI for upper frame border
	mwa #dli system.dliv	;Set next DLI
	mva #>disco_charset chbase
	sta wsync
	lda #0
	sta colbk
	sta hposp1	;No left or right borders
	sta hposm1
	sta dli.count+1
	rts
	.endp

	.proc dli	;Called per disco row and for lower frame border
	pha
	txa
	pha
	tya
	pha
count	ldx #0
	cpx #disco_rows
	bcc normal_row

	jsr main_screen.show_lower_border.with_p1
	jmp return

normal_row
	lda disco_row_xlo,x
	and #3
	eor #3
	sta hscrol

	lda disco_row_color,x
	eor #4
	sta colpf1
	eor #4+8
	sta colpf0
	eor #6
	sta colpf2

return	inc count+1
	pla
	tay
	pla
	tax
	pla
	rti

	.endp

	.proc update_dl
	mva #row_state.not_used disco_state
	ldx #disco_rows-1
move_loop
	lda disco_row_state,x
	beq skip
	cmp #row_state.starting
	beq skip	
	cmp #row_state.waiting
	beq skip	

	clc
	lda disco_row_speed,x
	adc disco_row_index,x

	cmp #<[index_max+1]		;This includes the underlow below index_min
	bcs max_index

	sta disco_row_index,x
	jmp skip

max_index
	jsr execute.set_next_row_state

skip	ldy disco_row_index,x

	lda disco_row_dir,x
	bne is_right
	lda disco_curve_lo,y
	sta disco_row_xlo,x
	lda disco_curve_hi,y
	jmp is_left_or_right

is_right
	sec
	lda #<disco_curve_max
	sbc disco_curve_lo,y
	sta disco_row_xlo,x
	lda #>disco_curve_max
	sbc disco_curve_hi,y
is_left_or_right
	sta disco_row_xhi,x

	lda disco_row_state,x		;Compute cummulative state
	ora disco_state
	sta disco_state
	dex
	bpl move_loop

	ldx #disco_rows-1
lms_loop
	lda disco_row_xhi,x
	sta disco_vbi_temp
	lda disco_row_xlo,x
	lsr disco_vbi_temp
	ror
	lsr disco_vbi_temp
	ror
	ldy disco_dl.row_lms_offset,x
	sta disco_dl.lms+1,y
	sta disco_dl.lms+4,y
	sta disco_dl.lms+7,y
	sta disco_dl.lms+10,y
	sta disco_dl.lms+13,y
	dex
	bpl lms_loop
	rts
	.endp

	.proc print_row		;IN: <X>=row_number, OUT: <X>=row_number

	row_number = x1
	total_chars = x2
	total_length = x3
	char_count = x4
	length_count = x5

	sm_ptr = p1
	sm_ptr2 = p2

	stx row_number

	.proc clear_row		;Clear row and set sm_ptr2+1
	mva #0 fill_memory.value
	lda disco_row_addresses.hi,x
	sta sm_ptr2+1
	ldx #>disco_row_size
	ldy #<disco_row_size
	jsr fill_memory
	.endp

	.proc copy_to_disco_row_buffer	;Copy row and compute total_chars and set sm_ptr
	lda #0
	sta total_chars
	sta total_length
char_loop
	ldx row_number
	jsr disco_text.get_byte
	pha				;Remember character
	and #$7f
	ldy #disco_font.max_char-1
find_loop
	cmp disco_font.char_codes,y
	beq found
	dey
	bpl find_loop
	.if .def debug_mode
	.byte 2				;Error detection for unknown chars
	.endif
found	ldx total_chars
	inc total_chars
	lda disco_font.char_offsets,y
	sta disco_row_buffer.char_offsets,x
	lda disco_font.char_lengths,y
	sta disco_row_buffer.char_lengths,x
	clc
	adc total_length
	sta total_length
	pla				;Bit 7 set in last character?
	bpl char_loop

	lsr total_length
	lda #disco_row_offset
	sec
	sbc total_length
	sta sm_ptr

	.if .def debug_mode
	lda #0
	ldx total_chars
clear_loop
	cpx #disco_row_buffer.size
	beq clear_done
	sta disco_row_buffer.char_offsets,x
	sta disco_row_buffer.char_lengths,x
	inx
	bne clear_loop
clear_done
	.endif

	.endp

	.proc print_disco_row_buffer
	ldy #0
	sty char_count
char_loop
	ldx char_count
	cpx total_chars
	beq done

	lda disco_row_buffer.char_lengths,x
	sta length_count
	lda disco_row_buffer.char_offsets,x
	tax
column_loop
	mva sm_ptr2+1 sm_ptr+1
	lda disco_font.char_data.line1,x
	sta (p1),y
	inc p1+1
	lda disco_font.char_data.line2,x
	sta (p1),y
	inc p1+1
	lda disco_font.char_data.line3,x
	sta (p1),y
	inc p1+1
	lda disco_font.char_data.line4,x
	sta (p1),y
	inc p1+1
	lda disco_font.char_data.line5,x
	sta (p1),y
	inw p1
	inx
	dec length_count
	bne column_loop
	inc char_count
	jmp char_loop
done	ldx row_number
	rts
	.endp
	.endp

	
	.endp		;End of disco_screen

;===============================================================

	.proc disco_text

	.proc get_byte	;IN: <X>=number of row, OUT: <A>=next byte
	lda addresses.lo,x
	sta lda_addr+1
	lda addresses.hi,x
	sta lda_addr+2
lda_addr
	lda $ffff

	inc addresses.lo,x
	bne no_inc
	inc addresses.hi,x
no_inc	rts
	.endp

	.local addresses
lo	.byte <row1,<row2,<row3,<row4
hi	.byte >row1,>row2,>row3,>row4
	.endl

	icl "RGBA-Disco-Text.asm"

	.endp			;End of disco_text

;===============================================================

	.local disco_dl
	
	.byte $70,$70,$60+$80,$00

	.macro m_disco_row
	dc = $54
	.byte dc,a(disco_sm+:1*disco_row_size+0*disco_row_width+:2)
	.byte dc,a(disco_sm+:1*disco_row_size+1*disco_row_width+:2)
	.byte dc,a(disco_sm+:1*disco_row_size+2*disco_row_width+:2)
	.byte dc,a(disco_sm+:1*disco_row_size+3*disco_row_width+:2)
	.byte dc,a(disco_sm+:1*disco_row_size+4*disco_row_width+:2)
	.endm

	.byte $80,$60
lms	m_disco_row 0 $000
	.byte $80,$60
	m_disco_row 1 $000
	.byte $80,$60
	m_disco_row 2 $000
	.byte $80,$60
	m_disco_row 3 $100	;4k alignment

	.byte $60,$80

	.byte $41,a(disco_dl)

row_lms_offset
	.rept disco_rows
	.byte 17*#
	.endr

	.endl

	m_assert_same_1k disco_dl

;===============================================================

	.local disco_font

max_char	= 37
max_offset	= $ae

char_start	= *
char_codes	= char_start
char_offsets	= char_codes+max_char
char_lengths	= char_offsets+max_char
char_data	= char_lengths+max_char
char_data.line1	= char_data
char_data.line2	= char_data.line1+max_offset
char_data.line3	= char_data.line2+max_offset
char_data.line4	= char_data.line3+max_offset
char_data.line5	= char_data.line4+max_offset

	ins "font/RGBA-Disco-Font.bin"

charset_start
	ins "font/RGBA-Disco-Font.fnt",+0, $400

	.endl

;===============================================================

	.local disco_row_addresses

hi	.byte >[disco_sm+disco_row_size*0]
	.byte >[disco_sm+disco_row_size*1]
	.byte >[disco_sm+disco_row_size*2]
	.byte >[disco_sm+$1000]			;forced 4k alignment
	.if disco_rows <> 4
	.error disco_row_addresses," must be adapted".
	.endif
	.endl

	.endp		;End of disco