;
;	>>> R.G.B.A. - Rasters Girls Beer Atari by JAC! <<<
;
;	Loads to volatile memory and call init to compute pattern Y/X coordinates.
;
;	@com.wudsn.ide.asm.mainsourcefile=..\RGBA.asm

	.proc mosaic_pattern_loader
	
cip_mosaic_data_buffer	= $a000
cip_mosaic_data_size	= $828

	eof		= $fe
	eol		= $ff
	max_phase	= $57
	
	.proc init
phase_loop
	mwa #pattern source_ptr
	ldy #0
line_loop
	ldx #0
column_loop
source_ptr = *+1
	lda pattern,x
	bmi phase_done
phase_count = *+1
	cmp #0
	bne not_same_phase
	jsr store.yx
not_same_phase
	inx
	cpx #cip_sm_width
	bne column_loop
	adw source_ptr #40
	iny
	bne line_loop		

phase_done
	lda #eol
	jsr store.a
	inc phase_count
	lda phase_count
	cmp #max_phase
	bne phase_loop

	lda #eof
	jmp store.a		;Store end marker and return

	.proc store
yx	tya
	jsr store.a
	txa

a
sta_adr = *+1
	sta cip_mosaic_data_buffer
	inc sta_adr
	seq			;Save 1 cycle :-)
	rts
	inc sta_adr+1
	rts
	.endp

	.endp

	.proc copy
	m_copy_memory cip_mosaic_data_buffer cip_mosaic_data cip_mosaic_data_size
	rts
	.endp

	.local pattern
	ins "cip/RGBA-CIP-Mosaic-Pattern.bin"
	.byte eof
	.endl

	.endp
