;
;	>>> R.G.B.A. - Rasters Girls Beer Atari by JAC! <<<
;
;	Mosaic effect.
;
;	@com.wudsn.ide.asm.mainsourcefile=..\RGBA.asm

	.proc mosaic

	.enum active_state
	start    = $01
	done_one = $ff
	done_all = $fe
	.ende

direction .byte $40
active	.byte 0

	.proc init
fade_in	lda #opcode.sta_abs
	.byte $2c
fade_out
	lda #opcode.lda_abs
	sta execute.opcode+1
	mwa #cip_mosaic_data execute.next_pattern+1
	mva #active_state.start active
	clc
	lda direction
	sbc #$40
	sta direction	
	rts
	.endp

	.proc execute

	lda active
	lsr
	bcc done_one

loop	jsr next_pattern
	cmp #active_state.done_all
	beq done_all
	cmp #active_state.done_one
	beq done_one

	.if .def debug_mode
	cmp #cip_sm_lines
	bcc skip
	jam
skip
	.endif

	bit direction
	bpl no_y_mirror
	eor #$ff
	clc
	adc #cip_sm_lines
no_y_mirror
	tay

	jsr next_pattern
	.if .def debug_mode
	cmp #cip_sm_width
stop_x	bcs stop_x
	.endif

	bit direction
	bvc no_x_mirror
	eor #$ff
	clc
	adc #cip_sm_width
no_x_mirror
	sta xcount
	sty ycount
	jsr cut.check_mask	;<A>=x position, <Y>=y position
	bne loop		;No store

	lda xcount
	clc
	adc cip_sm_offsets.lo,y
	sta sm_sta_lo_ptr
	sta sm_sta_hi_ptr
	sta sm_ptr

	lda cip_sm_offsets.hi,y
	adc #>[cip_sm_sta_lo]	;Keep ascending order of high byte deltas!
	sta sm_sta_lo_ptr+1
	adc #>[cip_sm_sta_hi-cip_sm_sta_lo]
	sta sm_sta_hi_ptr+1
	adc #>[cip_sm-cip_sm_sta_hi]
	sta sm_ptr+1

	ldy #0
	lda (sm_sta_lo_ptr),y
	sta code_ptr
	lda (sm_sta_hi_ptr),y
	sta code_ptr+1

opcode	lda #opcode.sta_abs
	sta (code_ptr),y
	cmp #opcode.sta_abs	;Equals fade_in
	beq loop
	ldy #0			;Template code
;callback_adr = *+1
;	jsr $ffff		;IN: xcount, ycount, <Y>=0, sm_ptr
	ldx ycount
	lda cip_charsetchr0,x	;Restore raster bar chars
	sta (sm_ptr),y
	jmp loop		;Branch always

done_all
	sta active
done_one
	rts

	.proc next_pattern
	lda cip_mosaic_data
	inw next_pattern+1
	rts
	.endp

	.endp			;End of execute

	.endp			;End of mosaic