;
;	>>> R.G.B.A. - Rasters Girls Beer Atari by JAC! <<<
;
;	Overlay effect.
;
;	@com.wudsn.ide.asm.mainsourcefile=..\RGBA.asm

	.proc overlay

texture_ptr1	= p1
texture_ptr2	= p2
texture_width	= 40+32	;Textures are $b88 bytes, $1000 bytes are reserver
texture_lines	= 25+16

cip_buffer1		= $9600	;$1000 bytes
cip_buffer2		= $a600	;$1000 bytes, overlaps cip_rasters_base by $200 bytes

texture_squares_lo	= cip_free_f8+$000	;$100 bytes
texture_squares_hi	= cip_free_f8+$100	;$100 bytes
cip_buffer_offsets_lo 	= cip_free_f8+$200	;$100 bytes
cip_buffer_offsets_hi 	= cip_free_f8+$300	;$100 bytes

	.proc init

	m_init_squares init_squares_callback 0

	ldx #<init_chr_code_callback
	ldy #>init_chr_code_callback
	jsr init_chr_code

	ldx #<init_sm_code_callback
	ldy #>init_sm_code_callback
	jmp init_sm_code
	
	.proc init_stripes
	mwa #cip_buffer1 buffer_ptr
	mwa #init_buffer_callback.stripes init_buffer.jsr_adr
	mva #init_buffer_callback.color_mode.red init_buffer_callback.stripes.color_mode_opcode
	mva #$40 init_buffer_callback.bit_mask
	ldx #texture_width
	ldy #[texture_lines]
	jsr init_buffer.normal

	mwa #cip_buffer2 buffer_ptr
	mwa #init_buffer_callback.stripes init_buffer.jsr_adr
	mva #init_buffer_callback.color_mode.blue init_buffer_callback.stripes.color_mode_opcode
	mva #$20 init_buffer_callback.bit_mask
	ldx #texture_width
	ldy #[texture_lines]
	jmp init_buffer.normal
	.endp
	
	.proc init_circles
	mwa #cip_buffer1 buffer_ptr
	mva #init_buffer_callback.color_mode.red init_buffer_callback.circle.color_mode_opcode
	mwa #init_buffer_callback.circle init_buffer.jsr_adr
	mva #$d0 init_buffer_callback.bit_mask
	ldx #texture_width
	ldy #[texture_lines+1]/2
	jsr init_buffer.mirrored

	mwa #cip_buffer2 buffer_ptr
	mva #init_buffer_callback.color_mode.blue init_buffer_callback.circle.color_mode_opcode
	mwa #init_buffer_callback.circle init_buffer.jsr_adr
	mva #$e0 init_buffer_callback.bit_mask
	ldx #texture_width
	ldy #[texture_lines+1]/2
	jmp init_buffer.mirrored
	.endp

	.proc init_buffer	;IN: buffer_ptr, <X>=width, <Y>=[lines] or [lines+1]/2 if mirrored
	buffer_ptr2 = sm_ptr

mirrored			;Only half of the offset table will be filled!
	lda #opcode.sta_zpy	;Write to second address
	.byte $2c
normal	lda #opcode.lda_zpy	;Do not write to second address
	sta mirror_opcode

	stx width_adr
	sty lines_adr

	adw buffer_ptr #texture_width*texture_lines buffer_ptr2

	mva buffer_ptr+1 buffer_start_adr
	lda #0
	sta ycount
loop_y	lda #0
	sta xcount
	ldy ycount
	lda buffer_ptr
	sta cip_buffer_offsets_lo,y
	lda buffer_ptr+1
	sec
buffer_start_adr = *+1
	sbc #0
	sta cip_buffer_offsets_hi,y
loop_x
jsr_adr	= *+1
	jsr $ffff
	ldy #0
	sta (buffer_ptr),y
	inw buffer_ptr
mirror_opcode
	sta (buffer_ptr2),y
	dew buffer_ptr2
	inc xcount
	lda xcount
width_adr = *+1
	cmp #0
	bne loop_x
	lda #0
	sta xcount
	inc ycount
	lda ycount
lines_adr = *+1
	cmp #0
	bne loop_y
	rts
	.endp

;===============================================================

	.proc init_squares_callback	;IN: <X>=index
	txa
	lda init_squares.shifted_value
	sta texture_squares_lo,x
	lda init_squares.shifted_value+1
	sta texture_squares_hi,x 
	rts
	.endp

;===============================================================

 	.proc init_buffer_callback
 
 	.enum color_mode
		red = opcode.rts
		blue = opcode.asl
	.ende
 
	.var bit_mask	.byte
 
	.proc stripes
	lda xcount
	clc
	adc ycount
	bit bit_mask
	bne black
	and #15
	cmp #8
	bcc skip
	eor #15
skip	
color_mode_opcode
	asl
	asl
	asl
	rts
	.endp

	.proc circle
	texture_width_offset = texture_width/2
	textture_lines_offset = texture_lines/2

	lda xcount			;Mirror X to keep value symmetric and small
	sec
	sbc #texture_width_offset
	bcs no_mirrorx
	lda #texture_width_offset+1	;+1 because of <C>=0
	sbc xcount
no_mirrorx
	asl
	tax

	lda ycount			;Mirror Y to keep value symmetric and small
	sbc #textture_lines_offset
	bcs no_mirrory
	lda #textture_lines_offset+1	;+1 because of <C>=0
	sbc ycount
no_mirrory
	asl
	tay

	clc
	lda texture_squares_lo,x
	adc texture_squares_lo,y
	sta square_root.loop_exact.operand_lo
	lda texture_squares_hi,x
	adc texture_squares_hi,y
	sta square_root.loop_exact.operand_hi

	.if .def debug_mode
	bcc no_overflow
	jam
no_overflow
	.endif

	lsr			;SQRT(X)<X/2 for all X
	tax			;Optimizes starting value

	.proc square_root
	lda loop_exact.operand_hi
	.proc loop_hi 
	cmp texture_squares_hi,x
	inx
	bcc loop_hi
	.endp
	m_assert_same_page loop_hi

;	sec			;Set once outside the loop
	.proc loop_exact

operand_lo = *+1
	lda #0
	sbc texture_squares_lo,x
operand_hi = *+1
	lda #0
	sbc texture_squares_hi,x
	inx
	.if .def debug_mode
	bne no_overflow
	jam
no_overflow
	.endif

	bcs loop_exact
	.endp
	m_assert_same_page loop_exact

	.endp


	txa
	bit bit_mask
	beq black
	and #15
	cmp #8
	bcc skip
	eor #15
skip

color_mode_opcode
	asl			;ASL or RTS
	asl
	asl
	rts
	.endp

	.proc black
	lda #0
	rts
	.endp

	.endp

;===============================================================
	.proc init_chr_code_callback
	.use effects.cip.init_chr_code

;	lda char_count	;Lower 3 bite luma
	and #7
	tax

	lda char_count	;Upper 3 bits luma
	lsr
	lsr
	lsr

	sta tmp1	;Maximum luma tmp1 = max(<A>,<X>)
	cpx tmp1
	scc
	stx tmp1

	tay		;Compute chroma
	lda color_map1,x
	ora color_map2,y
	tay		;Same for whole character

	asl tmp1
	asl tmp1
	ldx tmp1
	rts

	.local color_map1
	chroma = $3
	.byte $00,chroma,chroma,chroma,chroma,chroma,chroma,chroma
	.endl

	.local color_map2
	chroma = $8
	.byte $00,chroma,chroma,chroma,chroma,chroma,chroma,chroma
	.endl

	.endp
 ;===============================================================

	.proc init_sm_code_callback
	php

	lda xcount
	bne is_not_new_line
	lda ycount
	beq is_not_new_line

	jsr store_code
	.byte 22
	.byte $18
	.byte $a5, texture_ptr1	;lda texture_ptr1
	.byte $69, texture_width;adc #texture_width
	.byte $85, texture_ptr1	;sta texture_ptr1
	.byte $90, $02		;bcc skip
	.byte $e6, texture_ptr1+1;inc texture_ptr1+1

	.byte $18
	.byte $a5, texture_ptr2	;lda texture_ptr2
	.byte $69, texture_width;adc #cip_texture_width_width
	.byte $85, texture_ptr2	;sta texture_ptr2
	.byte $90, $02		;bcc skip
	.byte $e6, texture_ptr2+1;inc texture_ptr2+1

is_not_new_line
	plp
	bcs skip
	lda #$a0		;ldy #<xcount>
	ldx xcount
	jsr store_code_ax

	jsr store_code
	.byte 4
	.byte $b1, texture_ptr1	;lda (texture_ptr1),y
	.byte $11, texture_ptr2	;ora (texture_ptr2),y

	clc
skip	rts			;Generate STA code if mask is not set


	.endp	;End of init_sm_code_callback

	.endp	;End of init

;===============================================================

	.proc execute

cnt1	= *+1
	lda #0
	clc
speed1	= *+1
	adc #0
	sta cnt1
	tax
	mva #>cip_buffer1 buffer_ptr+1
	lda #texture_ptr1
	jsr position_texture

cnt2	= *+1
	lda #0
	clc
speed2	= *+1
	adc #0
	sta cnt2
	tax
	mva #>cip_buffer2 buffer_ptr+1
	lda #texture_ptr2
	jsr position_texture

	ldy #0
	jsr cip_code
	rts

	.proc position_texture		;IN: buffer_ptr+1 = high byte, <A>=pointer zero page address, <X>=sine position
	pha

	lda sinus.sintab64_256,x
	lsr
	sta xcount			;Between 0..31
	lda sinus.sintab64_256+64,x
	lsr
	lsr
	sta ycount			;Between 0..15

	pla				;Get pointer zero page address

at_xy_count
	tax
	lda xcount
	ldy ycount
	clc
	adc cip_buffer_offsets_lo,y
	sta $00,x
	lda #0
	adc cip_buffer_offsets_hi,y
	adc buffer_ptr+1
	sta $01,x
	rts
	.endp

	.endp		;End of execute

;===============================================================

	.endp	;End of overlay
	
	m_info overlay
