;
;	>>> R.G.B.A. - Rasters Girls Beer Atari by JAC! <<<
;
;	Character interlace fractal.
;
;	@com.wudsn.ide.asm.mainsourcefile=RGBA.asm

.proc fractal
;var iter:integer;
;    x,y,x2,y2:real;
;    temp:real;
;
;begin
;X:=0;y:=0;x2:=0;y2:=0;
;iter:=0;
;while (iter < maxiter) and (x2+y2 < 10000) do begin
;      temp:=x2-y2+cx;
;      y:=2*x*y+cy;
;      x:=temp;
;      x2:=x*x;
;      y2:=y*y;
;      iter:=iter+1
;      end;
;MSetLevel:=iter;
;end;

	.proc init

	jsr mult.init_tables
	ldx #<generate_sm_code
	ldy #>generate_sm_code
	jsr init_sm_code

	rts

	.proc generate_sm_code

	bcs no_store	

	lda xcount
	ldy ycount
	ldx #x3			;2 bytes
	jsr mult.calc
	lda x3
	lsr x3+1
	ror
	lsr x3+1
	ror
	lsr x3+1
	ror
;	lsr x3+1
;	ror

	and #127
	ora #64
	ldy #0
	sta (sm_ptr),y
no_store

no_line
	sec			;Do not generate STA code
	rts
	.endp
	
	.endp

	.proc execute
	rts
	.endp

	.endp			;End of fractal


	.proc mult
;Fast Multiplication
;
;The idea stems from Stephen Judd.
;You find it in The Fridge and in the C=Hacking magazine:
;
;Let f(x) = x^2 / 4.  Then
;
;       a*b = f(a+b) - f(a-b)
;
;You need 2 tables of squares with 9 bit input size and
;16 bit result size.
;
;You can save the building of the 2th complement
;
;   EOR #$ff
;   CLC
;   ADC #1
;
;by shifting the second table 1 byte down and
;using the 1th complement:
;
;   EOR #$ff
;
;This algorithm is very useful when you want to multiply
;multiple bytes by the same factor. Then you can set the
;zp addresses once and just modify the y register.
;With the same trick you can easily extend this algorithm
;to 16 bit. But if you want to be fast you will need more
;than the 8 zp addresses.


zp1=$20			;8 bytes zp index addresses
zp2=$22
zp3=$24
zp4=$26

tab1=$b000 		;2 kbytes square tables
tab2=$b200
tab3=$b400
tab4=$b600


	.proc calc
	sta zp1		;set zp adresses
	sta zp2
	eor #$ff
	sta zp3
	sta zp4

	sec
	lda (zp1),y
	sbc (zp3),y
	sta $00,x
	lda (zp2),y
        sbc (zp4),y	;product hi in a
	sta $01,x
        rts
        .endp

	.proc init_tables	;first build the tables tab1..tab4 and init zp1-zp4 hi bytes
	ldx #0		;build square tables
	stx tab3+$fe
	stx tab4+$fe
	ldy #$ff

loop1	txa
	lsr
	clc
	adc tab3+$fe,x
	sta tab1,x
	sta tab3+$ff,x
	sta tab3,y
	lda #0
	adc tab4+$fe,x
	sta tab2,x
	sta tab4+$ff,x
	sta tab4,y
	dey
	inx
	bne loop1

loop2	txa
	sec
	ror
	clc
	adc tab1+$ff,x
	sta tab1+$100,x
	lda #0
	adc tab2+$ff,x
	sta tab2+$100,x
	inx
	bne loop2

	lda #>tab1  ;init zp addresses
	sta zp1+1
	lda #>tab2
	sta zp2+1
	lda #>tab3
	sta zp3+1
	lda #>tab4
	sta zp4+1
	rts
	.endp
	
	.endp