	//Colour constants
    var fc_cmt="#888";
	var fc_html="#11a";
	var fc_quot="#a24";
	var fc_kwds="#008";
	
	//Language keywords
	var fc_java_kwds="public|int|float|double|private|new|void|synchronized|if|for|byte|break|else";
	
    var pres=document.getElementsByTagName("pre");
	for (var a=0; a<pres.length; a++) {
	  var elem=pres[a];
	  if (elem.className.toLowerCase()=='code') formatCode(elem);
	}
	
	function formatCode(precode) {
	  var lang=precode.lang.toLowerCase();
      var textlines=precode.innerHTML.split(/\r|\n/);
      var linecount=1;
	  var newcode="";
	  
	  //Process each line of text
      for (var b=0; b<textlines.length; b++) {
	    var code=textlines[b];
		//Remove line/form feed characters
		code=code.replace(/\f|\n/g,"");
  	    //Decode special HTML elements
		if (lang=="html") code=code.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;");
  		//Double quoted string
		code=code.replace(/(".+")/g,"<span style=\"color: "+fc_quot+";\">$1</span>");
		//Single quoted string
		code=code.replace(/('.+')/g,"<span style=\"color: "+fc_quot+";\">$1</span>");
		  
    	//HTML
	    if (lang=="html") {
		  //tags
	      code=code.replace(/&lt;(\S.*?)&gt;/g,"<span style=\"color: "+fc_html+";\">&lt;$1&gt;</span>");
		  //comments
		  code=code.replace(/&lt;!--/g,"<span style=\"color: "+fc_cmt+";\">&lt;!--");
		  code=code.replace(/--&gt;/g,"--&gt;</span>");
	    }
		  
		//Java
		if (lang=="java") {
		  //comments
		  code=code.replace(/(\/\/.*)/,"<span style=\"color: "+fc_cmt+";\">$1</span>");
		  //keywords
		  code=colourKeywords(fc_java_kwds,code);
		}
		  
		//Pseudo
		if (lang=="pseudo") {
		  //comments
		  code=code.replace(/(\/\/.*)/,"<span style=\"color: "+fc_cmt+";\">$1</span>");
		}
		  
		//Accumulate line numbers and reformatted text
		var formatline=("   "+linecount).slice(-3);
		newcode+="<span style=\"background: #bbb; color: #000; border-right: solid 2px #2b2; padding-right: 7px;\">"+formatline+"</span>"+code+"<br />";
		linecount++;
      }	  
	  
      //Assign formatted text back to PRE element
	  //The outerHTML is used for IE so that
	  //whitespace is retained.
	  if ("outerHTML" in elem) {
	    elem.outerHTML="<pre class='code'><code>"+newcode+"</code></pre>";
	  } else {
	    elem.innerHTML=newcode;
	  }
	}
	
	function colourKeywords(keywords,codeline) {
	  var wordre=new RegExp("("+keywords+") ","gi");
	  return codeline.replace(wordre,"<span style=\"color: "+fc_kwds+";\">$1 </span>");
	}
  