;
;	>>> R.G.B.A. - Rasters Girls Beer Atari by JAC! <<<
;
;	Hires interlace screen routine.
;
;	@com.wudsn.ide.asm.mainsourcefile=..\RGBA.asm

	.proc tip_screen

	.proc init

	jsr main_screen.init	;Temporary black screen

	jsr init_dls
	jsr fade.clear_sm

	ldx #<do_vbi
	ldy #>do_vbi
	jmp system.set_vbiv

	.proc init_dls		;dl1 and dl2 are assumed to be at a page boundary
	dl_ptr = p1

	mwa #0 dl_ptr
	sta store_dl1+1
	sta store_dl2+1
	mva #>tip_dl1 store_dl1+2
	mva #>tip_dl2 store_dl2+2

	lda #$70
	jsr store_both
	jsr store_both
	lda #$60+$80
	jsr store_both
	lda #$00
	jsr store_both

	ldx #0
loop	jsr generate_gr11

	ora #>tip_sm09
	jsr store_dl1
	lda dl_ptr+1
	ora #>tip_sm10
	jsr store_dl2
	jsr next_line

	jsr generate_gr11

	ora #>tip_sm10
	jsr store_dl1
	lda dl_ptr+1
	ora #>tip_sm09
	jsr store_dl2
	jsr next_line

	bne loop
	lda #$41
	jsr store_both
	lda #<tip_dl1
	jsr store_both
	lda #>tip_dl1
	jmp store_both

generate_gr11
	jsr store_both_4f
	lda dl_ptr
	jsr store_both
	lda dl_ptr+1
	ora #>tip_sm11
	jsr store_both
	jsr store_both_4f
	lda dl_ptr
	jsr store_both
	lda dl_ptr+1
	rts

store_both_4f
	lda #$4f		;Fall though

store_both
	jsr store_dl2
store_dl1
	sta tip_dl1
        inw store_dl1+1
        rts

store_dl2
        sta tip_dl2
        inw store_dl2+1
        rts

next_line
	lda dl_ptr
	sta tip_sm_offset_lo,x
	clc
	adc #tip_sm_width
	sta dl_ptr
	lda dl_ptr+1
	sta tip_sm_offset_hi,x
	adc #0
	sta dl_ptr+1
       	inx
       	cpx #tip_lines
        rts
 
	.endp	;End of init_dls

	.endp	;End of init

;===============================================================

	.proc do_vbi
	jsr main_screen.set_vbi_defaults

;	Set DLPTR, DMACTL, SYSTEM.DLIV, DLI.KERNELV
	lda cnt
	lsr
	lda #>tip_dl1
	ldx #tip_prior09
	ldy #tip_prior10
	bcc is_dl1
	lda #>tip_dl2
	ldx #tip_prior10
	ldy #tip_prior09
is_dl1	sta dlptr+1
	stx do_kernel.kernel_loop.even_line+1
	sty do_kernel.kernel_loop.odd_line+1
	lda #0
	sta dlptr
	mva #mask_dmactl dmactl
	mwa #main_screen.dli_upper_border system.dliv
	mwa #do_kernel main_screen.dli_upper_border.kernelv
	rts
	.endp

	.proc do_kernel
	ldx #0
	ldy #tip_prior11
;	ldy #tip_prior_split
	.proc kernel_loop
	sta wsync

;	lda #tip_prior11	;2 cycles
;	sta prior		;4 cycles
	sty prior
	lda #0
	sta colbk

;	bit $00			;3 cycles
	lda tip_maskp0tab,x
	sta hposp0
	lda tip_maskm0tab,x
	sta hposm0
;	jsr delay.fourteen_cycles
;split1	sty tip_split_reg
	inx

	sta wsync
even_line
	lda #tip_prior10
	sta prior
;	bit $00
;	jsr delay.thirty_cycles
;split2	sty tip_split_reg

	sta wsync
;	lda #tip_prior11
;	sta prior
	sty prior
	lda tip_maskp0tab,x
	sta hposp0
	lda tip_maskm0tab,x
	sta hposm0
;	bit $00
;	jsr delay.fourteen_cycles	
;split3	sty tip_split_reg
	inx
odd_line
	lda #tip_prior09
	sta wsync
	sta prior
;	bit $00
	cpx #tip_lines
;	jsr delay.thirty_cycles
;split4	sty tip_split_reg
	bne kernel_loop
	.endp

	m_assert_same_page kernel_loop

	jmp main_screen.show_lower_border.without_p1
	
;	.proc delay
;thirty_cycles
;	jsr fourteen_cycles
;	nop
;fourteen_cycles
;	nop
;	rts
;	.endp

	.end		;End of kernel

;===============================================================

	.proc fade

	.proc in
	jsr cut.fill_buffer
	mva #$ff cut.cut_visible
	jmp fill_sm
	.endp

	.proc out
	lda #>tip_sm09
	sta sm09_adr+2
	lda #>tip_sm10
	sta sm10_adr+2
	lda #>tip_sm11
	sta sm11_adr+2

	ldx #0
	stx sm09_adr+1
	stx sm10_adr+1
	stx sm11_adr+1
clear_line
	ldy #tip_sm_width-1
	lda #0
clear_byte
sm09_adr
	sta tip_sm09,y
sm10_adr
	sta tip_sm10,y
sm11_adr
	sta tip_sm11,y
	dey
	bpl clear_byte

	lda #mask_hposp1	;Cover P1 with P0 and M1 with M0
	sta tip_maskp0tab,x
	lda #mask_hposm1
	sta tip_maskm0tab,x

	lda sm09_adr+1
	add #tip_sm_width
	sta sm09_adr+1
	sta sm10_adr+1
	sta sm11_adr+1
	bcc no_inc_hi
	inc sm09_adr+2
	inc sm10_adr+2
	inc sm11_adr+2
no_inc_hi
	jsr sync.cnt

	inx
	cpx #tip_lines
	bne clear_line
	jmp cut.next
	.endp

	.proc clear_sm
	jsr main_screen.clear_mask_p0_m0
	m_fill_memory tip_sm09 tip_frame_size $00
	m_fill_memory tip_sm10 tip_frame_size tip_black8*$11
	m_fill_memory tip_sm11 tip_frame_size $00
	rts
	.endp

	.proc fill_sm
	tip_sm09_ptr = p1
	tip_sm10_ptr = p2
	tip_sm11_ptr = p3

	mwa cut.cut_sm09_ptr tip_sm09_ptr
	mwa cut.cut_sm10_ptr tip_sm10_ptr
	mwa cut.cut_sm11_ptr tip_sm11_ptr
	
	lda cut.cut_start
	sta sm09_adr+1
	sta sm10_adr+1
	sta sm11_adr+1

	lda #>tip_sm09
	sta sm09_adr+2
	lda #>tip_sm10
	sta sm10_adr+2
	lda #>tip_sm11
	sta sm11_adr+2

	ldx #0
copy_line
	txa
	tay
	lda (cut.cut_maskp0_ptr),y
	sta tip_maskp0tab,y
	lda (cut.cut_maskm0_ptr),y
	sta tip_maskm0tab,y

	ldy cut.cut_width
	dey
copy_byte
	lda (tip_sm09_ptr),y
sm09_adr
	sta tip_sm09,y
	lda (tip_sm10_ptr),y
sm10_adr
	sta tip_sm10,y
	lda (tip_sm11_ptr),y
sm11_adr
	sta tip_sm11,y
	dey
	bpl copy_byte

	ldy cut.cut_width
	tya
	add tip_sm09_ptr
	sta tip_sm09_ptr
	scc
	inc tip_sm09_ptr+1

	tya
	add tip_sm10_ptr
	sta tip_sm10_ptr
	scc
	inc tip_sm10_ptr+1

	tya
	add tip_sm11_ptr
	sta tip_sm11_ptr
	scc
	inc tip_sm11_ptr+1

	lda sm09_adr+1
	add #tip_sm_width
	sta sm09_adr+1
	sta sm10_adr+1
	sta sm11_adr+1
	bcc no_inc_hi
	inc sm09_adr+2
	inc sm10_adr+2
	inc sm11_adr+2

no_inc_hi
	jsr sync.cnt
	inx
	cpx #tip_lines
	bne copy_line
	rts
	.endp		;End of fill_sm

	.endp		;End of fade
	
	.endp		;End of tip_screen