;
;	>>> R.G.B.A. - Rasters Girls Beer Atari by JAC! <<<
;
;	Shades Bobs effect.
;
;	@com.wudsn.ide.asm.mainsourcefile=..\RGBA.asm

	.proc shades

	speeds_shift=5
	offsets_shift = 91

	.proc init

	ldx #0
	stx shade_increase
	lda #2
	inx
loop	sta shade_increase,x
	clc
	adc #1
	sne
	lda #1
	inx
	bne loop

again	ldx #<init_masks_callback
	ldy #>init_masks_callback
	jsr init_masks

	mwa #shade_buffer sm_ptr
	mwa #tip_sm09 sm09_ptr
	mwa #tip_sm10 sm10_ptr
	mwa #tip_sm11 sm11_ptr

	lda #0
	sta ycount
loop_y	lda #0
	sta xcount
loop_x	ldy ycount
	lda xcount
	jsr cut.check_mask
	eor #$ff
	and #1
	ldy #tip_sm_width*0
	sta (sm_ptr),y
	ldy #tip_sm_width*1
	sta (sm_ptr),y
	ldy #tip_sm_width*2
	sta (sm_ptr),y
	ldy #tip_sm_width*3
	sta (sm_ptr),y
	lsr				;<A>=$00 or $01
	bcc no_fill

	ldy #tip_sm_width*0
	lda #0
	sta (sm09_ptr),y
	sta (sm11_ptr),y
	lda #tip_black8*$11
	sta (sm10_ptr),y

	ldy #tip_sm_width*1
	lda #0
	sta (sm09_ptr),y
	sta (sm11_ptr),y
	lda #tip_black8*$11
	sta (sm10_ptr),y

	ldy #tip_sm_width*2
	lda #0
	sta (sm09_ptr),y
	sta (sm11_ptr),y
	sta (sm10_ptr),y

	ldy #tip_sm_width*3
	lda #0
	sta (sm09_ptr),y
	sta (sm11_ptr),y
	lda #tip_black8*$11
	sta (sm10_ptr),y
no_fill
	inw sm_ptr
	inw sm09_ptr
	inw sm10_ptr
	inw sm11_ptr

	inc xcount
	lda xcount
	cmp #cip_sm_width
	bne loop_x
	adw sm_ptr #tip_sm_width*3
	adw sm09_ptr #tip_sm_width*3
	adw sm10_ptr #tip_sm_width*3
	adw sm11_ptr #tip_sm_width*3

	lda #0			;For exomizer
	sta xcount

	inc ycount
	lda ycount
	cmp #cip_sm_lines
	jne loop_y
	rts

	.proc init_masks_callback;IN: <X>=0...255, OUT: <A>=$00..fe (even values)
	stx oldx
	txa
	clc
offset_adr = *+1
	adc #$3f
	tax

	asl
	and #$f0
	sta chroma
	txa
	lsr
	and #$0e
chroma	= *+1
	ora #$00

oldx	= *+1
	ldx #0
	rts
	.endp

	.proc next
	clc
	lda init_masks_callback.offset_adr
	adc #$20
	sta init_masks_callback.offset_adr
	ldx #3
loop	dec execute.speeds,x
	lsr execute.offsets,x
	dex
	bpl loop
	jmp init.again
	.endp

	.endp

;===============================================================

	.proc execute

	xcnt1	= effect_zp+0
;	ycnt1	= effect_zp+1
;	xcnt2	= effect_zp+2
;	ycnt2	= effect_zp+3

	xcnt1_tmp = effect_zp+4
	ycnt1_tmp = effect_zp+5
	xcnt2_tmp = effect_zp+6
	ycnt2_tmp = effect_zp+7

	cnt	  = effect_zp+8

	ldx #3
move_loop
	clc
	lda xcnt1,x
	adc speeds,x
	sta xcnt1,x
	sta xcnt1_tmp,x
	dex
	bpl move_loop

	mva #7 cnt
plot_loop
	jsr plot_bob

	ldx #3
offset_loop
	clc
	lda xcnt1_tmp,x
	adc offsets,x
	sta xcnt1_tmp,x
	dex
	bpl offset_loop

	dec cnt
	bne plot_loop
	rts

	.local speeds
	.byte 3+speeds_shift,2+speeds_shift,7+speeds_shift,4+speeds_shift
	.endl

	.local offsets
	.byte 2+offsets_shift,5+offsets_shift,3+offsets_shift,7+offsets_shift
	.endl

;===============================================================

	.proc plot_bob		;IN: counts
	ldx xcnt1_tmp
	ldy ycnt1_tmp
	clc
	lda sinus.sintab48_256,x
	adc sinus.sintab48_256,y
	ror
	sec
	sbc #8
	scs
	rts
	cmp #tip_sm_width-4
	scc
	rts
	sta xcount

	ldx xcnt2_tmp
	ldy ycnt2_tmp
	clc
	lda sinus.sintab48_256,x
	adc sinus.sintab48_256,y
	cmp #tip_lines-12
	scc
	rts

	tay
	lda tip_sm_offset_lo,y
	clc
	adc xcount
	sta sm_ptr
	sta sm09_ptr
	sta sm10_ptr
	sta sm11_ptr
	lda tip_sm_offset_hi,y
	adc #>shade_buffer
	sta sm_ptr+1
	adc #>[tip_sm09-shade_buffer]
	sta sm09_ptr+1
	adc #>[tip_sm10-tip_sm09]
	sta sm10_ptr+1
	adc #>[tip_sm11-tip_sm10]
	sta sm11_ptr+1		;Now <C>=0

	jsr plot_6_lines	;Does not change <C>
;	clc			;Still <C>=0
	lda sm_ptr
	adc #240
	sta sm_ptr
	sta sm09_ptr
	sta sm10_ptr
	sta sm11_ptr
	bcc no_inc_high
	inc sm_ptr+1
	inc sm09_ptr+1
	inc sm10_ptr+1
	inc sm11_ptr+1
no_inc_high

	.proc plot_6_lines
	ldy #0
	jsr plot_line
	ldy #40
	jsr plot_line
	ldy #80
	jsr plot_line
	ldy #120
	jsr plot_line
	ldy #160
	jsr plot_line
	ldy #200

	.proc plot_line
	.macro m_plot
	.byte opcode.lax_izy,sm_ptr	;LAX (sm_ptr),y
	lda (sm_ptr),y
	beq skip
	lda shade_increase,x
	sta (sm_ptr),y
	lda or_mask_09,x
	sta (sm09_ptr),y
	lda or_mask_10,x
	sta (sm10_ptr),y
	lda or_mask_11,x
	sta (sm11_ptr),y
skip
	.endm

	m_plot
	iny
	m_plot
	iny
	m_plot
	iny
	m_plot
	rts
	.endp		;End of plot_line

	.endp		;End of plot_7_lines

	.endp		;End of plot_bob
	
	.endp		;End of execute

	.endp		;End of shades

